// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/v2/model.proto

#include "google/cloud/bigquery/internal/model_connection_impl.h"
#include "google/cloud/bigquery/internal/model_option_defaults.h"
#include "google/cloud/background_threads.h"
#include "google/cloud/common_options.h"
#include "google/cloud/grpc_options.h"
#include "google/cloud/internal/retry_loop.h"
#include <memory>

namespace google {
namespace cloud {
namespace bigquery_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ModelServiceConnectionImpl::ModelServiceConnectionImpl(
    std::unique_ptr<google::cloud::BackgroundThreads> background,
    std::shared_ptr<bigquery_internal::ModelServiceStub> stub, Options options)
    : background_(std::move(background)),
      stub_(std::move(stub)),
      options_(internal::MergeOptions(
          std::move(options), bigquery_internal::ModelServiceDefaultOptions(
                                  ModelServiceConnection::options()))) {}

StatusOr<google::cloud::bigquery::v2::Model>
ModelServiceConnectionImpl::GetModel(
    google::cloud::bigquery::v2::GetModelRequest const& request) {
  return google::cloud::internal::RetryLoop(
      retry_policy(), backoff_policy(), idempotency_policy()->GetModel(request),
      [this](grpc::ClientContext& context,
             google::cloud::bigquery::v2::GetModelRequest const& request) {
        return stub_->GetModel(context, request);
      },
      request, __func__);
}

StatusOr<google::cloud::bigquery::v2::ListModelsResponse>
ModelServiceConnectionImpl::ListModels(
    google::cloud::bigquery::v2::ListModelsRequest const& request) {
  return google::cloud::internal::RetryLoop(
      retry_policy(), backoff_policy(),
      idempotency_policy()->ListModels(request),
      [this](grpc::ClientContext& context,
             google::cloud::bigquery::v2::ListModelsRequest const& request) {
        return stub_->ListModels(context, request);
      },
      request, __func__);
}

StatusOr<google::cloud::bigquery::v2::Model>
ModelServiceConnectionImpl::PatchModel(
    google::cloud::bigquery::v2::PatchModelRequest const& request) {
  return google::cloud::internal::RetryLoop(
      retry_policy(), backoff_policy(),
      idempotency_policy()->PatchModel(request),
      [this](grpc::ClientContext& context,
             google::cloud::bigquery::v2::PatchModelRequest const& request) {
        return stub_->PatchModel(context, request);
      },
      request, __func__);
}

Status ModelServiceConnectionImpl::DeleteModel(
    google::cloud::bigquery::v2::DeleteModelRequest const& request) {
  return google::cloud::internal::RetryLoop(
      retry_policy(), backoff_policy(),
      idempotency_policy()->DeleteModel(request),
      [this](grpc::ClientContext& context,
             google::cloud::bigquery::v2::DeleteModelRequest const& request) {
        return stub_->DeleteModel(context, request);
      },
      request, __func__);
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquery_internal
}  // namespace cloud
}  // namespace google
