// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/v2/model.proto

#include "google/cloud/bigquery/internal/model_stub.h"
#include "google/cloud/grpc_error_delegate.h"
#include "google/cloud/status_or.h"
#include <google/cloud/bigquery/v2/model.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace bigquery_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

ModelServiceStub::~ModelServiceStub() = default;

StatusOr<google::cloud::bigquery::v2::Model> DefaultModelServiceStub::GetModel(
    grpc::ClientContext& client_context,
    google::cloud::bigquery::v2::GetModelRequest const& request) {
  google::cloud::bigquery::v2::Model response;
  auto status = grpc_stub_->GetModel(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::bigquery::v2::ListModelsResponse>
DefaultModelServiceStub::ListModels(
    grpc::ClientContext& client_context,
    google::cloud::bigquery::v2::ListModelsRequest const& request) {
  google::cloud::bigquery::v2::ListModelsResponse response;
  auto status = grpc_stub_->ListModels(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

StatusOr<google::cloud::bigquery::v2::Model>
DefaultModelServiceStub::PatchModel(
    grpc::ClientContext& client_context,
    google::cloud::bigquery::v2::PatchModelRequest const& request) {
  google::cloud::bigquery::v2::Model response;
  auto status = grpc_stub_->PatchModel(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return response;
}

Status DefaultModelServiceStub::DeleteModel(
    grpc::ClientContext& client_context,
    google::cloud::bigquery::v2::DeleteModelRequest const& request) {
  google::protobuf::Empty response;
  auto status = grpc_stub_->DeleteModel(&client_context, request, &response);
  if (!status.ok()) {
    return google::cloud::MakeStatusFromRpcError(status);
  }
  return google::cloud::Status();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquery_internal
}  // namespace cloud
}  // namespace google
