// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/bigquery/v2/model.proto

#include "google/cloud/bigquery/model_connection_idempotency_policy.h"
#include "absl/memory/memory.h"
#include <memory>

namespace google {
namespace cloud {
namespace bigquery {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

using ::google::cloud::Idempotency;

ModelServiceConnectionIdempotencyPolicy::
    ~ModelServiceConnectionIdempotencyPolicy() = default;

namespace {
class DefaultModelServiceConnectionIdempotencyPolicy
    : public ModelServiceConnectionIdempotencyPolicy {
 public:
  ~DefaultModelServiceConnectionIdempotencyPolicy() override = default;

  /// Create a new copy of this object.
  std::unique_ptr<ModelServiceConnectionIdempotencyPolicy> clone()
      const override {
    return absl::make_unique<DefaultModelServiceConnectionIdempotencyPolicy>(
        *this);
  }

  Idempotency GetModel(
      google::cloud::bigquery::v2::GetModelRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency ListModels(
      google::cloud::bigquery::v2::ListModelsRequest const&) override {
    return Idempotency::kIdempotent;
  }

  Idempotency PatchModel(
      google::cloud::bigquery::v2::PatchModelRequest const&) override {
    return Idempotency::kNonIdempotent;
  }

  Idempotency DeleteModel(
      google::cloud::bigquery::v2::DeleteModelRequest const&) override {
    return Idempotency::kNonIdempotent;
  }
};
}  // namespace

std::unique_ptr<ModelServiceConnectionIdempotencyPolicy>
MakeDefaultModelServiceConnectionIdempotencyPolicy() {
  return absl::make_unique<DefaultModelServiceConnectionIdempotencyPolicy>();
}

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace bigquery
}  // namespace cloud
}  // namespace google
